package com.cognifide.slice.validation.api;

/*
 * #%L
 * Slice - Core API
 * $Id:$
 * $HeadURL:$
 * %%
 * Copyright (C) 2012 Cognifide Limited
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */

import java.util.List;

/**
 * Result of validation.
 * 
 * @author Jan Kuźniak
 * @author Rafał Malinowski
 */
public interface ValidationResult {
	/**
	 * Validates object.
	 * 
	 * @return true if model object is valid, false otherwise.
	 */
	ValidationState getValidationState();

	/**
	 * Checks if object is blank.
	 */
	boolean isBlank();

	/**
	 * Check if object is valid.
	 */
	boolean isValid();

	/**
	 * @return list of error messages. Can be empty or null.
	 */
	List<ErrorMessage> getErrorMessages();

}
